#!/usr/bin/env bash
# ----------------------------------------------------------------------
# execution en séquence, des créations des images 
# R. Suinot : remi<at>suinot<point>org
# # 10/10/2022
# Rev : 02/11/2023
# Rev : 07/12/2023 : mise en place d'arguments et de fonctions
# Rev : 27/12/2023 : chaque dockerfile doit avoir le nom de l'image 
#                    recherchée dans son nom, exemple:
#                    -> maria-spip = nom dans le docker-compose 
#                    Docker.maria-spip = nom du fichier Docker
# ----------------------------------------------------------------------
# --- Variables --------------------------------------------------------
RED=`tput setaf 1`
VERT=`tput setaf 2`
JAUNE=`tput setaf 3`
NORMAL=`tput setaf 7`
dir=$(basename `pwd`)

image=$(cat docker-compose.yml | grep image  | awk '{print $2}')
dir=$(basename `pwd`)
IFS='
'
tableau_images=( $(cat docker-compose.yml | grep image | awk '{print $2}') )
# echo "${tableau_images[0]}"                                                 
# echo "${tableau_images[1]}"                                                 

# --- Fin Variables ----------------------------------------------------


# ----------------------------------------------------------------------
# --- Fonction ---------------------------------------------------------
Help()
{
        echo " Reconstruction de l'image docker "
        echo $RED
        echo " $0 -d        "$NORMAL": destruction du contenaire + de l\'image de base + reconstruction"
        echo $JAUNE
        echo " $0 -c ou -r  "$NORMAL": destruction du contenaire + reconstruction"
        echo $VERT
        echo " $0 -h ou sans argument"$NORMAL" : help                                                 "
}


Arret()
{
        docker ps -a | grep $dir | awk '{print $11}' 2>/dev/null
        if [ $? ]; then
                echo "destruction du container actuel ..."
                docker compose down
        fi
}
Destruction()
{
        echo "destruction des images complètes pour reconstruction..."
        #docker rmi $image
        for img in ${tableau_images[@]}
        do
                echo "|                      "
                echo "+-- destruction de $img"
                docker rmi $img
        done
}

Create()
{
        for img in ${tableau_images[@]}
        do
                echo "|                      "
                echo "+-- création de $img"
                docker build -f ./Docker.$img -t $img .
        done
}
# --- Fin Fonction -----------------------------------------------------

if [ $(id -u) -eq 0 ]
then
   echo "Ce script doit être lancé en tant qu'utilisateur simple"
   exit 1
fi

if [ -n "$1" ]
then
        if [ "$1" == "-d" ]
        then
                # Arret
                Arret
                Destruction
                Create
        elif [ "$1" = "-c" -o "$1" = "-r" ]
        then
                Arret
                Create
        elif [ "$1" = "-h" ]
        then
                # help
                Help
                exit 0
        fi
else
        Help
        exit 0
fi

# Démarrage!
docker compose up -d

exit 0

